"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const path = require("path");
const minimist = require("minimist");
const Raven = require("raven");
Raven.config("https://05cdf9fe436f4b058c893701e0a577c8@sentry.io/1253080").install();
const project_1 = require("./project");
process.title = "Framer Project";
// Stop when `stdin` closes. This make sure we quit when Framer exits unexpectedly.
process.stdin.resume();
process.stdin.on("end", () => {
    process.exit();
});
const usage = () => {
    console.log(`
Usage:
    - install <project.framer>        Install the dependencies.
    - add <project.framer> <package>  Add dependency.
    - build <project.framer>          Build the JavaScript.
    - serve <project.framer>          Run a http server with auto reload.

Options:
    --staticPath=<path>               Serve a path at /static
    --cachePath=<path>                Use a custom cache path
    --author=<name>                   Set author if there is none [HACK!]
`);
};
const main = () => __awaiter(this, void 0, void 0, function* () {
    const argv = minimist(process.argv.slice(2));
    if (argv._.length < 2)
        return usage();
    const command = _.first(argv._) || "serve";
    const staticPath = argv.staticPath;
    const cachePath = argv.cachePath || "/tmp/framer";
    const project = new project_1.Project(path.resolve(argv._[1]), staticPath, cachePath, argv.author);
    const packageName = argv._[2];
    if (command === "serve") {
        let port = argv.port || argv.p || 4567;
        yield project.serve([port, port + 100]);
        process.title += ` ${project.serverPort}`;
        yield project.install();
        project.watch();
        yield project.updatePackageInfo();
        return; // don’t exit
    }
    else if (command === "build") {
        yield project.install();
        yield project.build();
    }
    else if (command === "install") {
        yield project.install();
    }
    else if (command === "add" && packageName) {
        yield project.add(packageName, false);
    }
    else {
        usage();
    }
    process.exit();
});
main();
